diff --git a/README b/README
deleted file mode 100644
index d4296a9..0000000
--- a/README
+++ /dev/null
@@ -1,147 +0,0 @@
-* What's Ruby
-
-Ruby is the interpreted scripting language for quick and
-easy object-oriented programming.  It has many features to
-process text files and to do system management tasks (as in
-Perl).  It is simple, straight-forward, and extensible.
-
-
-* Features of Ruby
-
-  + Simple Syntax
-  + *Normal* Object-Oriented features(ex. class, method calls)
-  + *Advanced* Object-Oriented features(ex. Mix-in, Singleton-method)
-  + Operator Overloading
-  + Exception Handling
-  + Iterators and Closures
-  + Garbage Collection
-  + Dynamic Loading of Object files(on some architecture)
-  + Highly Portable (works on many Unix-like/POSIX compatible platforms
-    as well as Windows, Mac OS X, BeOS etc.)
-    cf. http://bugs.ruby-lang.org/projects/ruby-trunk/wiki/SupportedPlatforms
-
-
-* How to get Ruby
-
-The Ruby distribution files can be found in the following FTP site:
-
-  ftp://ftp.ruby-lang.org/pub/ruby/
-
-The trunk of the Ruby source tree can be checked out with the
-following command:
-
-  $ svn co http://svn.ruby-lang.org/repos/ruby/trunk/ ruby
-
-Or if you are using git then use following command:
-
-  $ git clone git://github.com/ruby/ruby.git
-
-There are some other branches under development.  Try the following
-command and see the list of branches:
-
-  $ svn ls http://svn.ruby-lang.org/repos/ruby/branches/
-
-Or if you are using git then use following command:
-
-  $ git ls-remote git://github.com/ruby/ruby.git
-
-* Ruby home-page
-
-The URL of the Ruby home-page is:
-
-   http://www.ruby-lang.org/
-
-
-* Mailing list
-
-There is a mailing list to talk about Ruby.
-To subscribe this list, please send the following phrase
-
-	subscribe YourFirstName YourFamilyName
-e.g.
-        subscribe Joseph Smith
-
-in the mail body (not subject) to the address <ruby-talk-ctl@ruby-lang.org>.
-
-
-* How to compile and install
-
-This is what you need to do to compile and install Ruby:
-
-  1. If ./configure does not exist or is older than configure.in,
-     run autoconf to (re)generate configure.
-
-  2. Run ./configure, which will generate config.h and Makefile.
-
-     Some C compiler flags may be added by default depending on your
-     environment.  Specify optflags=.. and warnflags=.. as necessary
-     to override them.
-
-  3. Edit defines.h if you need.  Usually this step will not be needed.
-
-  4. Remove comment mark(#) before the module names from ext/Setup (or
-     add module names if not present), if you want to link modules
-     statically.
-
-     If you don't want to compile non static extension modules
-     (probably on architectures which does not allow dynamic loading),
-     remove comment mark from the line "#option nodynamic" in
-     ext/Setup.
-
-  5. Run make.
-
-  6. Optionally, run 'make check' to check whether the compiled Ruby
-     interpreter works well.  If you see the message "check succeeded",
-     your ruby works as it should (hopefully).
-
-  7. Run 'make install'
-
-     This command will create following directories and install files
-     onto them.
-
-       * ${DESTDIR}${prefix}/bin
-       * ${DESTDIR}${prefix}/include/ruby-${MAJOR}.${MINOR}.${TEENY}
-       * ${DESTDIR}${prefix}/include/ruby-${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
-       * ${DESTDIR}${prefix}/lib
-       * ${DESTDIR}${prefix}/lib/ruby
-       * ${DESTDIR}${prefix}/lib/ruby/${MAJOR}.${MINOR}.${TEENY}
-       * ${DESTDIR}${prefix}/lib/ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
-       * ${DESTDIR}${prefix}/lib/ruby/site_ruby
-       * ${DESTDIR}${prefix}/lib/ruby/site_ruby/${MAJOR}.${MINOR}.${TEENY}
-       * ${DESTDIR}${prefix}/lib/ruby/site_ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
-       * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby
-       * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby/${MAJOR}.${MINOR}.${TEENY}
-       * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
-       * ${DESTDIR}${prefix}/lib/ruby/gems/${MAJOR}.${MINOR}.${TEENY}
-       * ${DESTDIR}${prefix}/share/man/man1
-       * ${DESTDIR}${prefix}/share/ri/${MAJOR}.${MINOR}.${TEENY}/system
-
-     If Ruby's API version is `x.y.z', the ((|${MAJOR}|)) is `x', the
-     ((|${MINOR}|)) is `y', and the ((|${TEENY}|)) is `z'.
-
-     NOTE: teeny of the API version may be different from one of
-     Ruby's program version
-
-     You may have to be a super user to install ruby.
-
-If you fail to compile ruby, please send the detailed error report with
-the error log and machine/OS type, to help others.
-
-
-* Copying
-
-See the file COPYING.
-
-
-* The Author
-
-Feel free to send comments and bug reports to the author.  Here is the
-author's latest mail address:
-
-  matz@netlab.jp
-
--------------------------------------------------------
-created at: Thu Aug  3 11:57:36 JST 1995
-Local variables:
-mode: indented-text
-end:
diff --git a/README.rdoc b/README.rdoc
new file mode 100644
index 0000000..ccb6e78
--- /dev/null
+++ b/README.rdoc
@@ -0,0 +1,143 @@
+= \What's Ruby
+
+Ruby is the interpreted scripting language for quick and
+easy object-oriented programming.  It has many features to
+process text files and to do system management tasks (as in
+Perl).  It is simple, straight-forward, and extensible.
+
+
+== Features of Ruby
+
+* Simple Syntax
+* *Normal* Object-Oriented features(ex. class, method calls)
+* *Advanced* Object-Oriented features(ex. Mix-in, Singleton-method)
+* Operator Overloading
+* Exception Handling
+* Iterators and Closures
+* Garbage Collection
+* Dynamic Loading of Object files(on some architecture)
+* Highly Portable (works on many Unix-like/POSIX compatible platforms
+  as well as Windows, Mac OS X, BeOS etc.)
+  cf. http://bugs.ruby-lang.org/projects/ruby-trunk/wiki/SupportedPlatforms
+
+
+== How to get Ruby
+
+The Ruby distribution files can be found in the following FTP site:
+
+ftp://ftp.ruby-lang.org/pub/ruby/
+
+The trunk of the Ruby source tree can be checked out with the
+following command:
+
+  $ svn co http://svn.ruby-lang.org/repos/ruby/trunk/ ruby
+
+Or if you are using git then use following command:
+
+  $ git clone git://github.com/ruby/ruby.git
+
+There are some other branches under development.  Try the following
+command and see the list of branches:
+
+  $ svn ls http://svn.ruby-lang.org/repos/ruby/branches/
+
+Or if you are using git then use following command:
+
+  $ git ls-remote git://github.com/ruby/ruby.git
+
+== Ruby home-page
+
+The URL of the Ruby home-page is:
+
+http://www.ruby-lang.org/
+
+
+== Mailing list
+
+There is a mailing list to talk about Ruby.
+To subscribe this list, please send the following phrase
+
+	subscribe YourFirstName YourFamilyName
+e.g.
+        subscribe Joseph Smith
+
+in the mail body (not subject) to the address ruby-talk-ctl@ruby-lang.org.
+
+
+== How to compile and install
+
+This is what you need to do to compile and install Ruby:
+
+1.  If +./configure+ does not exist or is older than configure.in, run autoconf to
+    (re)generate configure.
+
+2.  Run +./configure+, which will generate config.h and Makefile.
+
+    Some C compiler flags may be added by default depending on your environment.
+    Specify +optflags=..+ and +warnflags=..+ as necessary to override them.
+
+3.  Edit +defines.h+ if you need. Usually this step will not be needed.
+
+4.  Remove comment mark(#) before the module names from +ext/Setup+ (or add
+    module names if not present), if you want to link modules statically.
+
+    If you don't want to compile non static extension modules (probably on
+    architectures which does not allow dynamic loading), remove comment mark from
+    the line "+#option nodynamic+" in +ext/Setup+.
+
+5.  Run +make+.
+
+6.  Optionally, run '<tt>make check</tt>' to check whether the compiled Ruby
+    interpreter works well. If you see the message "check succeeded", your ruby
+    works as it should (hopefully).
+
+7.  Run '<tt>make install</tt>'
+
+    This command will create following directories and install files onto them.
+
+      * ${DESTDIR}${prefix}/bin
+      * ${DESTDIR}${prefix}/include/ruby-${MAJOR}.${MINOR}.${TEENY}
+      * ${DESTDIR}${prefix}/include/ruby-${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
+      * ${DESTDIR}${prefix}/lib
+      * ${DESTDIR}${prefix}/lib/ruby
+      * ${DESTDIR}${prefix}/lib/ruby/${MAJOR}.${MINOR}.${TEENY}
+      * ${DESTDIR}${prefix}/lib/ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
+      * ${DESTDIR}${prefix}/lib/ruby/site_ruby
+      * ${DESTDIR}${prefix}/lib/ruby/site_ruby/${MAJOR}.${MINOR}.${TEENY}
+      * ${DESTDIR}${prefix}/lib/ruby/site_ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
+      * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby
+      * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby/${MAJOR}.${MINOR}.${TEENY}
+      * ${DESTDIR}${prefix}/lib/ruby/vendor_ruby/${MAJOR}.${MINOR}.${TEENY}/${PLATFORM}
+      * ${DESTDIR}${prefix}/lib/ruby/gems/${MAJOR}.${MINOR}.${TEENY}
+      * ${DESTDIR}${prefix}/share/man/man1
+      * ${DESTDIR}${prefix}/share/ri/${MAJOR}.${MINOR}.${TEENY}/system
+
+    If Ruby's API version is `x.y.z', the ((|${MAJOR}|)) is `x', the ((|${MINOR}|))
+    is `y', and the ((|${TEENY}|)) is `z'.
+
+    NOTE: teeny of the API version may be different from one of Ruby's program
+    version
+
+    You may have to be a super user to install ruby.
+
+    If you fail to compile ruby, please send the detailed error report with the
+    error log and machine/OS type, to help others.
+
+
+== Copying
+
+See the file COPYING.
+
+
+== The Author
+
+Feel free to send comments and bug reports to the author.  Here is the author's
+latest mail address:
+
+matz@netlab.jp
+
+-------------------------------------------------------
+created at: Thu Aug  3 11:57:36 JST 1995
+Local variables:
+mode: indented-text
+end: